// control charging of battery on apple M1
// tested on macbook pro 2021 model
// works on linux

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <syslog.h>

int main(int argc, char **argv) {

	int i;
	int option;
	int limit = 90;

while ((option = getopt(argc, argv, "l:uh")) != -1) {
	switch (option) {
		case 'h':
      puts("help");
      puts("-l limit capacity");
      break;
    case 'l':
			limit = atoi(optarg);
			printf("limit: %d\n", limit);
			break;
		default:                          /* '?' */
      puts("unknown option");
    }
  }

	pid_t pid, sid;
	pid = fork();
	if (pid < 0) {
		exit(EXIT_FAILURE);
	}
	if (pid > 0) {
			exit(EXIT_SUCCESS);
	}

	umask(0);
	sid = setsid();
	if (sid < 0) {
		exit(EXIT_FAILURE);
	}

	if ((chdir("/")) < 0) {
		exit(EXIT_FAILURE);
	}

	close(STDIN_FILENO);
	close(STDOUT_FILENO);
	close(STDERR_FILENO);

	FILE * cb;
	FILE * capfile;
	char cbeh[20];
	char cap[6];
	int icap;
	char LOGNAME[] = "charge-ctl";
	char aut[] = "auto";
	char inh[] = "inhibit-charge";
	char dis[] = "force-discharge";

	void change (char *what) {
		cb = fopen("/sys/class/power_supply/macsmc-battery/charge_behaviour", "w");
		if (cb == NULL) {
			printf("problem with open\n");
			exit(EXIT_FAILURE);
		}
		fprintf(cb, "%s", what);
		fclose(cb);
		openlog(LOGNAME, LOG_PID, LOG_USER);
		syslog(LOG_USER | LOG_INFO, what);
	}

	while (1) {
		capfile = fopen("/sys/class/power_supply/macsmc-battery/capacity", "r");
		fgets(cap, 5, capfile);
		fclose(capfile);
		icap = atoi(cap);
		printf("cap: %d\n", icap);
		if (icap < 70) {
			change(aut);
		} else if (icap > 90) {
			change(dis);
		} else {
			change(inh);
		}
		sleep(30);
	}

	exit(EXIT_SUCCESS);
}


